require core.fs
require numbers.fs
require syntax.fs

: scm-bind ( a-addr u-nchars wval wenv -- )
    >r scm-make-variable >r scm-make-symbol r> swap r>
    scm-environment-define! ;

: scm-define-proc ( a-addr u-nchars xt wenv -- )
    dup >r swap scm-make-procedure r> scm-bind ;

: scm-define-macro ( a-addr u-nchars xt wenv -- )
    dup >r swap scm-make-macro r> scm-bind ;

: scm-create-toplevel-env ( -- wtoplevel )
    scm-bool-f scm-make-environment >r
    s" define" ['] scm.~define r@ scm-define-macro
    s" set!" ['] scm.~set! r@ scm-define-macro
    s" lambda" ['] scm.~lambda r@ scm-define-macro
    s" begin" ['] scm.~begin r@ scm-define-macro
    s" if" ['] scm.~if r@ scm-define-macro
    
    s" +" ['] scm.+ r@ scm-define-proc
    s" -" ['] scm.- r@ scm-define-proc
    s" *" ['] scm.* r@ scm-define-proc
    s" /" ['] scm./ r@ scm-define-proc
    s" <" ['] scm./ r@ scm-define-proc
    
    s" list" ['] scm.list r@ scm-define-proc
    s" map" ['] scm.map r@ scm-define-proc
    s" for-each" ['] scm.for-each r@ scm-define-proc
    s" display" ['] scm.display r@ scm-define-proc
    s" newline" ['] scm.newline r@ scm-define-proc

    r> ;




\ arch-tag: 559e94ce-0c4e-44ce-8c4e-df7d270ca115
\ (do not remove this comment)
