require f-scm.fs

: foo-str s" foo" ;
: bar-str s" bar" ;

: make-inum-list ( n -- wlist )
    scm-eol swap 0 u+do
	i scm-make-inum scm-cons
    loop ;

: make-list1 ( w -- wlist )
    scm-eol swap scm-cons ;

scm-bool-f scm-make-environment constant tl-env
tl-env scm-make-environment constant a-env
77 scm-make-inum constant const-77
const-77 make-list1 constant list-77
5 scm-make-inum scm-make-variable constant var-5
foo-str scm-make-symbol constant foo-sym
bar-str scm-make-symbol constant bar-sym
3 make-inum-list constant list-210

: bool-make-@ ( f -- f )
    scm-make-bool scm-bool@ ;

: make-2bool ( f1 f2 -- wbool1 wbool2 )
    scm-make-bool swap scm-make-bool swap ;

: 2bool@ ( wbool wbool -- f f )
    scm-bool@ swap scm-bool@ swap ;

: pair-cons-@ ( w w -- w w )
    scm-cons scm-pair@ ;

: inc ( w-inum - w-inum+1 )
    scm-inum@ 1+ scm-make-inum ;

: make-ident-closure ( wenv -- wproc )
    s" x" scm-make-symbol dup scm-eol swap scm-cons ( wenv wcode wformals )
    ~~ scm-make-closure ;

require test/tester.fs

{ 0 bool-make-@ -> 0 }
{ 23 bool-make-@ -> -1 }

{ 0 1 make-2bool pair-cons-@ 2bool@ -> 0 -1 }

{ s" foo" scm-make-symbol s" foo" scm-make-symbol = -> -1 }
{ s" bar" scm-make-symbol s" foo" scm-make-symbol = -> 0 }

{ var-5 foo-sym tl-env scm-environment-define! -> }
{ foo-sym tl-env scm-environment-lookup scm-variable? -> -1 }
{ foo-sym a-env scm-environment-lookup scm-variable? -> -1 }

{ tl-env foo-sym scm-eval dup scm-inum? swap scm-inum@ -> -1 5 }
{ a-env foo-sym scm-eval dup scm-inum? swap scm-inum@ -> -1 5 }

{ list-210 ' scm-inum@ scm-for-each -> 2 1 0 }

{ list-210 ' inc scm-map ' scm-inum@ scm-for-each -> 3 2 1 }

{ list-210 scm-list-length -> 3 }

{ list-77 tl-env make-ident-closure scm-procedure-apply -> const-77 }

\ s" test.scm" scm-load




\ arch-tag: 2902c09d-c88e-40fe-a5a8-2f7f9b423925
\ (do not remove this comment)
